/*
Copyright (C) 2015 NTT DATA Corporation

This program is free software; you can redistribute it and/or
Modify it under the terms of the GNU General Public License
as published by the Free Software Foundation, version 2.

This program is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied
warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE.  See the GNU General Public License for more details.
 */
package com.clustercontrol.xcloud.model.cloud;

import com.clustercontrol.xcloud.model.base.CollectionObserver;
import com.clustercontrol.xcloud.model.base.IElement;
import com.clustercontrol.xcloud.model.base.PropertyId;


public interface IComputeResources extends IElement {
	// プロパティの Id
	public interface p {
		static final PropertyId<CollectionObserver<IStorage>> storages = new PropertyId<CollectionObserver<IStorage>>("storages", true){};
		static final PropertyId<CollectionObserver<IInstance>> instances = new PropertyId<CollectionObserver<IInstance>>("instances", true){};
		static final PropertyId<CollectionObserver<INetwork>> networks = new PropertyId<CollectionObserver<INetwork>>("networks", true){};
	}

	ILocation getLocation();
	
	IInstance[] getInstances();
	IInstance getInstance(String instanceId);
	
	IStorage[] getStorages();
	void updateStorages();

	INetwork[] getNetworks();
	INetwork[] getNetworksWithInitializing();
	void updateNetworks();
}
